Environment Browser Query Config Target

Environment Browser Query Config Target
Queries for information about a specific target, a "physical" device that can be used to back virtual devices.

Queries for information about a specific target, a "physical" device that can be used to back virtual devices.

The ConfigTarget that is returned specifies the set of values that can be used in the device backings to connect the virtual machine to physical (or logical) host devices.

If the EnvironmentBrowser is from a ComputeResource or ClusterComputeResource, the host argument can be used to return the ConfigTarget provided by a particular host in the compute resource or cluster. If host is not specified and the EnvironmentBrowser is from a ComputeResource or ClusterComputeResource, then the union of all the devices is returned and the vim.vm.TargetInfo.configurationTag field indicates how widely the device is available across the compute resource or cluster.

If the EnvironmentBrowser is from a VirtualMachine a host should not be specified.

Required privileges: System.View

Request
URI
POST
https://{vcenter-host}/sdk/vim25/{release}/EnvironmentBrowser/{moId}/QueryConfigTarget
COPY
Path Parameters
string
moId
Required

The unique identifier for the managed object to which the method attaches; the serialized managed object reference for a request has the form moType/moId, in this case EnvironmentBrowser/{moId}.

string
release
Required

The vSphere release schema. The current specification covers vSphere 9.1.0.0 APIs.


Request Body
QueryConfigTargetRequestType of type(s) application/json
Optional
{
    "host": {
        "_typeName": "string",
        "type": "string",
        "value": "string"
    }
}
host
Optional

If specified, the host whose default BackingInfo is requested.

Authentication
This operation uses the following authentication methods.
Responses
200

Returns the ConfigTarget object. If invoked on a cluster with no hosts, null is returned.

{
    "_typeName": "string",
    "numCpus": 0,
    "numCpuCores": 0,
    "numNumaNodes": 0,
    "maxCpusPerHost": 0,
    "smcPresent": false,
    "datastore": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "datastore": {
                "_typeName": "string",
                "datastore": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                },
                "name": "string",
                "url": "string",
                "capacity": 0,
                "freeSpace": 0,
                "uncommitted": 0,
                "accessible": false,
                "multipleHostAccess": false,
                "type": "string",
                "maintenanceMode": "string"
            },
            "capability": {
                "_typeName": "string",
                "directoryHierarchySupported": false,
                "rawDiskMappingsSupported": false,
                "perFileThinProvisioningSupported": false,
                "storageIORMSupported": false,
                "nativeSnapshotSupported": false,
                "topLevelDirectoryCreateSupported": false,
                "seSparseSupported": false,
                "vmfsSparseSupported": false,
                "vsanSparseSupported": false,
                "upitSupported": false,
                "vmdkExpandSupported": false,
                "clusteredVmdkSupported": false
            },
            "maxFileSize": 0,
            "maxVirtualDiskCapacity": 0,
            "maxPhysicalRDMFileSize": 0,
            "maxVirtualRDMFileSize": 0,
            "mode": "string",
            "vStorageSupport": "string",
            "supportedVDiskFormats": [
                "string"
            ]
        }
    ],
    "network": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "network": {
                "_typeName": "string",
                "network": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                },
                "name": "string",
                "accessible": false,
                "ipPoolName": "string",
                "ipPoolId": 0
            },
            "vswitch": "string"
        }
    ],
    "opaqueNetwork": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "network": {
                "_typeName": "string",
                "network": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                },
                "name": "string",
                "accessible": false,
                "ipPoolName": "string",
                "ipPoolId": 0,
                "opaqueNetworkId": "string",
                "opaqueNetworkType": "string"
            },
            "networkReservationSupported": false
        }
    ],
    "distributedVirtualPortgroup": [
        {
            "_typeName": "string",
            "switchName": "string",
            "switchUuid": "string",
            "portgroupName": "string",
            "portgroupKey": "string",
            "portgroupType": "string",
            "uplinkPortgroup": false,
            "portgroup": {
                "_typeName": "string",
                "type": "string",
                "value": "string"
            },
            "networkReservationSupported": false,
            "backingType": "string",
            "logicalSwitchUuid": "string",
            "segmentId": "string",
            "subnetId": "string"
        }
    ],
    "distributedVirtualSwitch": [
        {
            "_typeName": "string",
            "switchName": "string",
            "switchUuid": "string",
            "distributedVirtualSwitch": {
                "_typeName": "string",
                "type": "string",
                "value": "string"
            },
            "networkReservationSupported": false
        }
    ],
    "subnetInfo": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "id": "string",
            "subnetFolderInfo": {
                "_typeName": "string",
                "name": "string",
                "folder": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            },
            "vpcFolderInfo": {
                "_typeName": "string",
                "name": "string",
                "folder": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            },
            "projectFolderInfo": {
                "_typeName": "string",
                "name": "string",
                "folder": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            },
            "rootFolderInfo": {
                "_typeName": "string",
                "name": "string",
                "folder": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            }
        }
    ],
    "cdRom": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "description": "string"
        }
    ],
    "serial": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ]
        }
    ],
    "parallel": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ]
        }
    ],
    "sound": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ]
        }
    ],
    "usb": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "description": "string",
            "vendor": 0,
            "product": 0,
            "physicalPath": "string",
            "family": [
                "string"
            ],
            "speed": [
                "string"
            ],
            "summary": {
                "_typeName": "string",
                "vm": {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                },
                "runtime": {
                    "_typeName": "string",
                    "device": [
                        {
                            "_typeName": "string",
                            "runtimeState": {
                                "_typeName": "string"
                            },
                            "key": 0
                        }
                    ],
                    "host": {
                        "_typeName": "string",
                        "type": "string",
                        "value": "string"
                    },
                    "connectionState": "string",
                    "powerState": "string",
                    "vmFailoverInProgress": false,
                    "faultToleranceState": "string",
                    "dasVmProtection": {
                        "_typeName": "string",
                        "dasProtected": false
                    },
                    "toolsInstallerMounted": false,
                    "suspendTime": "string",
                    "bootTime": "string",
                    "suspendInterval": 0,
                    "question": {
                        "_typeName": "string",
                        "id": "string",
                        "text": "string",
                        "choice": {
                            "_typeName": "string",
                            "valueIsReadonly": false,
                            "choiceInfo": [
                                {
                                    "_typeName": "string",
                                    "label": "string",
                                    "summary": "string",
                                    "key": "string"
                                }
                            ],
                            "defaultIndex": 0
                        },
                        "message": [
                            {
                                "_typeName": "string",
                                "id": "string",
                                "argument": [
                                    {
                                        "_typeName": "string"
                                    }
                                ],
                                "text": "string"
                            }
                        ]
                    },
                    "memoryOverhead": 0,
                    "maxCpuUsage": 0,
                    "maxMemoryUsage": 0,
                    "numMksConnections": 0,
                    "recordReplayState": "string",
                    "cleanPowerOff": false,
                    "needSecondaryReason": "string",
                    "onlineStandby": false,
                    "minRequiredEVCModeKey": "string",
                    "consolidationNeeded": false,
                    "offlineFeatureRequirement": [
                        {
                            "_typeName": "string",
                            "key": "string",
                            "featureName": "string",
                            "value": "string"
                        }
                    ],
                    "featureRequirement": [
                        {
                            "_typeName": "string",
                            "key": "string",
                            "featureName": "string",
                            "value": "string"
                        }
                    ],
                    "featureMask": [
                        {
                            "_typeName": "string",
                            "key": "string",
                            "featureName": "string",
                            "value": "string"
                        }
                    ],
                    "vFlashCacheAllocation": 0,
                    "paused": false,
                    "snapshotInBackground": false,
                    "quiescedForkParent": false,
                    "instantCloneFrozen": false,
                    "cryptoState": "string",
                    "suspendedToMemory": false,
                    "opNotificationTimeout": 0,
                    "iommuActive": false,
                    "consolidateWorkTotal": 0,
                    "consolidateWorkDone": 0,
                    "diskChainBroken": false
                },
                "guest": {
                    "_typeName": "string",
                    "guestId": "string",
                    "guestFullName": "string",
                    "toolsStatus": "string",
                    "toolsVersionStatus": "string",
                    "toolsVersionStatus2": "string",
                    "toolsRunningStatus": "string",
                    "hostName": "string",
                    "ipAddress": "string",
                    "hwVersion": "string"
                },
                "config": {
                    "_typeName": "string",
                    "name": "string",
                    "template": false,
                    "vmPathName": "string",
                    "memorySizeMB": 0,
                    "cpuReservation": 0,
                    "memoryReservation": 0,
                    "numCpu": 0,
                    "numEthernetCards": 0,
                    "numVirtualDisks": 0,
                    "uuid": "string",
                    "instanceUuid": "string",
                    "guestId": "string",
                    "guestFullName": "string",
                    "annotation": "string",
                    "product": {
                        "_typeName": "string",
                        "key": 0,
                        "classId": "string",
                        "instanceId": "string",
                        "name": "string",
                        "vendor": "string",
                        "version": "string",
                        "fullVersion": "string",
                        "vendorUrl": "string",
                        "productUrl": "string",
                        "appUrl": "string"
                    },
                    "installBootRequired": false,
                    "ftInfo": {
                        "_typeName": "string",
                        "role": 0,
                        "instanceUuids": [
                            "string"
                        ],
                        "configPaths": [
                            "string"
                        ],
                        "orphaned": false
                    },
                    "managedBy": {
                        "_typeName": "string",
                        "extensionKey": "string",
                        "type": "string"
                    },
                    "tpmPresent": false,
                    "numVmiopBackings": 0,
                    "hwVersion": "string"
                },
                "storage": {
                    "_typeName": "string",
                    "committed": 0,
                    "uncommitted": 0,
                    "unshared": 0,
                    "timestamp": "string"
                },
                "quickStats": {
                    "_typeName": "string",
                    "overallCpuUsage": 0,
                    "overallCpuDemand": 0,
                    "overallCpuReadiness": 0,
                    "guestMemoryUsage": 0,
                    "hostMemoryUsage": 0,
                    "guestHeartbeatStatus": "string",
                    "distributedCpuEntitlement": 0,
                    "distributedMemoryEntitlement": 0,
                    "staticCpuEntitlement": 0,
                    "staticMemoryEntitlement": 0,
                    "grantedMemory": 0,
                    "privateMemory": 0,
                    "sharedMemory": 0,
                    "swappedMemory": 0,
                    "balloonedMemory": 0,
                    "consumedOverheadMemory": 0,
                    "ftLogBandwidth": 0,
                    "ftSecondaryLatency": 0,
                    "ftLatencyStatus": "string",
                    "compressedMemory": 0,
                    "uptimeSeconds": 0,
                    "ssdSwappedMemory": 0,
                    "activeMemory": 0,
                    "memoryTierStats": [
                        {
                            "_typeName": "string",
                            "memoryTierType": "string",
                            "readBandwidth": 0
                        }
                    ]
                },
                "overallStatus": "string",
                "customValue": [
                    {
                        "_typeName": "string",
                        "key": 0
                    }
                ]
            }
        }
    ],
    "floppy": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ]
        }
    ],
    "legacyNetworkInfo": [
        {
            "_typeName": "string",
            "name": "string"
        }
    ],
    "scsiPassthrough": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "scsiClass": "string",
            "vendor": "string",
            "physicalUnitNumber": 0
        }
    ],
    "scsiDisk": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "capacity": 0,
            "vm": [
                {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            ],
            "disk": {
                "_typeName": "string",
                "deviceName": "string",
                "deviceType": "string",
                "key": "string",
                "uuid": "string",
                "descriptor": [
                    {
                        "_typeName": "string",
                        "quality": "string",
                        "id": "string"
                    }
                ],
                "canonicalName": "string",
                "displayName": "string",
                "lunType": "string",
                "vendor": "string",
                "model": "string",
                "revision": "string",
                "scsiLevel": 0,
                "serialNumber": "string",
                "durableName": {
                    "_typeName": "string",
                    "namespace": "string",
                    "namespaceId": 0,
                    "data": [
                        0
                    ]
                },
                "alternateName": [
                    {
                        "_typeName": "string",
                        "namespace": "string",
                        "namespaceId": 0,
                        "data": [
                            0
                        ]
                    }
                ],
                "standardInquiry": [
                    0
                ],
                "queueDepth": 0,
                "operationalState": [
                    "string"
                ],
                "capabilities": {
                    "_typeName": "string",
                    "updateDisplayNameSupported": false
                },
                "vStorageSupport": "string",
                "protocolEndpoint": false,
                "perenniallyReserved": false,
                "clusteredVmdkSupported": false,
                "applicationProtocol": "string",
                "dispersedNs": false,
                "deviceReservation": "string",
                "capacity": {
                    "_typeName": "string",
                    "blockSize": 0,
                    "block": 0
                },
                "devicePath": "string",
                "ssd": false,
                "localDisk": false,
                "physicalLocation": [
                    "string"
                ],
                "emulatedDIXDIFEnabled": false,
                "vsanDiskInfo": {
                    "_typeName": "string",
                    "vsanUuid": "string",
                    "formatVersion": 0
                },
                "scsiDiskType": "string",
                "usedByMemoryTiering": false
            },
            "transportHint": "string",
            "lunNumber": 0
        }
    ],
    "ideDisk": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "capacity": 0,
            "vm": [
                {
                    "_typeName": "string",
                    "type": "string",
                    "value": "string"
                }
            ],
            "partitionTable": [
                {
                    "_typeName": "string",
                    "id": 0,
                    "capacity": 0
                }
            ]
        }
    ],
    "maxMemMBOptimalPerf": 0,
    "supportedMaxMemMB": 0,
    "resourcePool": {
        "_typeName": "string",
        "memory": {
            "_typeName": "string",
            "reservationUsed": 0,
            "reservationUsedForVm": 0,
            "unreservedForPool": 0,
            "unreservedForVm": 0,
            "overallUsage": 0,
            "maxUsage": 0
        },
        "cpu": {
            "_typeName": "string",
            "reservationUsed": 0,
            "reservationUsedForVm": 0,
            "unreservedForPool": 0,
            "unreservedForVm": 0,
            "overallUsage": 0,
            "maxUsage": 0
        },
        "overallStatus": "string",
        "sharesScalable": "string"
    },
    "autoVmotion": false,
    "pciPassthrough": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "pciDevice": {
                "_typeName": "string",
                "id": "string",
                "classId": 0,
                "bus": 0,
                "slot": 0,
                "physicalSlot": 0,
                "slotDescription": "string",
                "function": 0,
                "vendorId": 0,
                "subVendorId": 0,
                "vendorName": "string",
                "deviceId": 0,
                "subDeviceId": 0,
                "parentBridge": "string",
                "deviceName": "string",
                "deviceClassName": "string",
                "directPathInfo": {
                    "_typeName": "string",
                    "interconnectType": "string",
                    "driverName": "string",
                    "driverVersion": "string",
                    "availableMemory": 0
                }
            },
            "systemId": "string"
        }
    ],
    "sriov": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "pciDevice": {
                "_typeName": "string",
                "id": "string",
                "classId": 0,
                "bus": 0,
                "slot": 0,
                "physicalSlot": 0,
                "slotDescription": "string",
                "function": 0,
                "vendorId": 0,
                "subVendorId": 0,
                "vendorName": "string",
                "deviceId": 0,
                "subDeviceId": 0,
                "parentBridge": "string",
                "deviceName": "string",
                "deviceClassName": "string",
                "directPathInfo": {
                    "_typeName": "string",
                    "interconnectType": "string",
                    "driverName": "string",
                    "driverVersion": "string",
                    "availableMemory": 0
                }
            },
            "systemId": "string",
            "virtualFunction": false,
            "pnic": "string",
            "devicePool": {
                "_typeName": "string",
                "key": "string"
            }
        }
    ],
    "vFlashModule": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "vFlashModule": {
                "_typeName": "string",
                "vFlashModule": "string",
                "vFlashModuleVersion": "string",
                "minSupportedModuleVersion": "string",
                "cacheConsistencyType": {
                    "_typeName": "string",
                    "valueIsReadonly": false,
                    "choiceInfo": [
                        {
                            "_typeName": "string",
                            "label": "string",
                            "summary": "string",
                            "key": "string"
                        }
                    ],
                    "defaultIndex": 0
                },
                "cacheMode": {
                    "_typeName": "string",
                    "valueIsReadonly": false,
                    "choiceInfo": [
                        {
                            "_typeName": "string",
                            "label": "string",
                            "summary": "string",
                            "key": "string"
                        }
                    ],
                    "defaultIndex": 0
                },
                "blockSizeInKBOption": {
                    "_typeName": "string",
                    "valueIsReadonly": false,
                    "min": 0,
                    "max": 0,
                    "defaultValue": 0
                },
                "reservationInMBOption": {
                    "_typeName": "string",
                    "valueIsReadonly": false,
                    "min": 0,
                    "max": 0,
                    "defaultValue": 0
                },
                "maxDiskSizeInKB": 0
            }
        }
    ],
    "sharedGpuPassthroughTypes": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "vgpu": "string"
        }
    ],
    "availablePersistentMemoryReservationMB": 0,
    "dynamicPassthrough": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "vendorName": "string",
            "deviceName": "string",
            "customLabel": "string",
            "vendorId": 0,
            "deviceId": 0
        }
    ],
    "sgxTargetInfo": {
        "_typeName": "string",
        "name": "string",
        "configurationTag": [
            "string"
        ],
        "maxEpcSize": 0,
        "flcModes": [
            "string"
        ],
        "lePubKeyHashes": [
            "string"
        ],
        "requireAttestationSupported": false
    },
    "precisionClockInfo": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "systemClockProtocol": "string"
        }
    ],
    "sevSupported": false,
    "vgpuDeviceInfo": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "deviceName": "string",
            "deviceVendorId": 0,
            "maxFbSizeInGib": 0,
            "timeSlicedCapable": false,
            "migCapable": false,
            "computeProfileCapable": false,
            "quadroProfileCapable": false
        }
    ],
    "vgpuProfileInfo": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "profileName": "string",
            "deviceVendorId": 0,
            "fbSizeInGib": 0,
            "profileSharing": "string",
            "profileClass": "string",
            "stunTimeEstimates": [
                {
                    "_typeName": "string",
                    "name": "string",
                    "configurationTag": [
                        "string"
                    ],
                    "migrationBW": 0,
                    "stunTime": 0
                }
            ]
        }
    ],
    "vendorDeviceGroupInfo": [
        {
            "_typeName": "string",
            "name": "string",
            "configurationTag": [
                "string"
            ],
            "deviceGroupName": "string",
            "deviceGroupDescription": "string",
            "componentDeviceInfo": [
                {
                    "_typeName": "string",
                    "type": "string",
                    "vendorName": "string",
                    "deviceName": "string",
                    "isConfigurable": false,
                    "device": {
                        "_typeName": "string",
                        "key": 0,
                        "deviceInfo": {
                            "_typeName": "string",
                            "label": "string",
                            "summary": "string"
                        },
                        "backing": {
                            "_typeName": "string"
                        },
                        "connectable": {
                            "_typeName": "string",
                            "migrateConnect": "string",
                            "startConnected": false,
                            "allowGuestControl": false,
                            "connected": false,
                            "status": "string"
                        },
                        "slotInfo": {
                            "_typeName": "string"
                        },
                        "controllerKey": 0,
                        "unitNumber": 0,
                        "numaNode": 0,
                        "deviceGroupInfo": {
                            "_typeName": "string",
                            "groupInstanceKey": 0,
                            "sequenceId": 0
                        }
                    }
                }
            ]
        }
    ],
    "maxSimultaneousThreads": 0,
    "dvxClassInfo": [
        {
            "_typeName": "string",
            "deviceClass": {
                "_typeName": "string",
                "label": "string",
                "summary": "string",
                "key": "string"
            },
            "vendorName": "string",
            "sriovNic": false,
            "configParams": [
                {
                    "_typeName": "string",
                    "label": "string",
                    "summary": "string",
                    "key": "string",
                    "optionType": {
                        "_typeName": "string",
                        "valueIsReadonly": false
                    }
                }
            ]
        }
    ],
    "sevSnpSupported": false,
    "tdxSupported": false,
    "vMotionBandwidth": [
        0
    ]
}

Code Samples
COPY
                    curl -X POST -H 'Authorization: <value>' -H 'Content-Type: application/json' -d '{}' https://{api_host}/sdk/vim25/{release}/EnvironmentBrowser/{moId}/QueryConfigTarget